package orm.generators;

import java.io.*;

public class BufferedGenWriter extends BufferedWriter {
	private String identStr = "\t";
	
	public BufferedGenWriter(Writer out) {
		super(out);
	}
	
	
	public BufferedGenWriter write(String str, int ident) throws IOException {
		writeIdent(ident);
		super.write(str);
		return this;
	}
	public BufferedGenWriter writeLine(String str) throws IOException {
		super.write(str);
		super.newLine();
		return this;
	}
	public BufferedGenWriter writeLine(String str, int ident) throws IOException {
		writeIdent(ident);
		return writeLine(str);
	}
	
	private void writeIdent(int ident) throws IOException {
		for(int i=0; i<ident; i++) {
			super.write(identStr);
		}
	}
	
	public void setIdentString(String ident) {
		identStr = ident;
	}
	public String getIdentString() {
		return identStr;
	}
	
}
