package orm.structure;

import java.lang.reflect.*;

import orm.api.relations.IRelation;
import orm.api.relations.ManyToManyRelation;
import orm.api.relations.ManyToOneRelation;
import orm.api.relations.OneToManyRelation;
import orm.api.relations.OneToOneRelation;

public enum RelationType {
	One_to_One {
			public IRelation getRelation(Field f) {return OneToOneRelation.getRelation(f);}
			},
	One_to_Many {
			public IRelation getRelation(Field f) {return OneToManyRelation.getRelation(f);}
			},
	Many_to_One {
			public IRelation getRelation(Field f) {return ManyToOneRelation.getRelation(f);}
			}, 
	Many_to_Many {
			public IRelation getRelation(Field f) {return ManyToManyRelation.getRelation(f);}
			};
	
	public abstract IRelation getRelation(Field f);
}
