package sql.sqlserver;

import java.util.Hashtable;

public enum SqlColumnType {
	INT {
		public String getSql() {
			return "int";
		}
	},
	SMALLINT {
		public String getSql() {
			return "smallint";
		}
	},
	BIGINT {
		public String getSql() {
			return "bigint";
		}
	},
	CHAR {
		public String getSql() {
			return "char";
		}
	},
	VARCHAR {
		public String getSql() {
			return "varchar";
		}
	},
	FLOAT {
		public String getSql() {
			return "float";
		}
	},
	DATETIME {
		public String getSql() {
			return "datetime";
		}
	}, 
	BIT {
		public String getSql() {
			return "bit";
		}
	},
	BYTE {
		public String getSql() {
			return "tinyint";
		}
	};
	
	//private SqlColumnType(String name) {
		
	//}
	
	public abstract String getSql();
	
	private static Hashtable<Class,SqlColumnType> mappedClasses = new Hashtable<Class,SqlColumnType>();
	
	public static SqlColumnType getSqlColumnType(Class c) throws SqlServerException {
		if (!mappedClasses.containsKey(c)) {
			if (int.class.equals(c) || Integer.class.equals(c)) {
				return INT;
			} else if (char.class.equals(c) || Character.class.equals(c)) {
				return CHAR;
			} else if (double.class.equals(c) || Double.class.equals(c) || float.class.equals(c) || Float.class.equals(c)) {
				return FLOAT;
			} else if (short.class.equals(c) || Short.class.equals(c)) {
				return SMALLINT;
			} else if (long.class.equals(c) || Long.class.equals(c)) {
				return BIGINT;
			} else if (java.sql.Date.class.equals(c) || java.util.Date.class.equals(c) || java.util.Calendar.class.equals(c)) {
				return DATETIME;
			} else if (boolean.class.equals(c) || Boolean.class.equals(c)) {
				return BIT;
			} else if (byte.class.equals(c) || Byte.class.equals(c)) {
				return BYTE;
			} else {
				System.out.println(c.getCanonicalName());
			}
		}

		return mappedClasses.get(c);
		
		//throw new SqlServerException("Invalid Class for mapping:" + c.getCanonicalName());
	}
}
