package sql.sqlserver.relations;

import orm.api.relations.IRelation;
import sql.sqlserver.ISqlRelation;
import sql.sqlserver.SqlTable;

public abstract class AbstractSqlRelation implements ISqlRelation {
	protected IRelation rel;
	protected SqlTable table;
	
	protected AbstractSqlRelation(SqlTable table, IRelation rel) {
		this.table = table;
		this.rel = rel;
	}
	
	public SqlTable getTable() {
		return table;
	}
	
	public String getRelColumnName() {
		return rel.getFieldStructure().getFieldName();
	}
	
	public boolean isBiDirect() {
		return false;
	}
	
	public IRelation getSourceRelation() {
		return rel;
	}

}
