package sql.sqlserver.relations;

import orm.api.relations.IBiDirectRelation;
import orm.api.relations.IRelation;
import sql.sqlserver.ISqlBiDirectRelation;
import sql.sqlserver.SqlServerException;
import sql.sqlserver.SqlTable;

public class SqlRelationManyToManyBiDirect extends SqlRelationManyToMany implements ISqlBiDirectRelation {

	public SqlRelationManyToManyBiDirect (SqlTable table, IRelation rel) {
		super(table, rel);
	}
	
	public String getName() {
		return ((IBiDirectRelation)super.rel).getRelationName();
	}

	private boolean is_created = false;
	public boolean isCreated() {
		return is_created;
	}
	
	public boolean isBiDirect() {
		return true;
	}
	
	protected String getLinkedTableName() {
		if (linkTableName == null) { 
			SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
			linkTableName = "link_" + table.getName() + "_" + referredTable.getName() + "_" + getName();
		}
		return linkTableName;
	}

	@Override
	public String getCreateSqlScript() throws SqlServerException {
		if (!is_created) {
			String res = super.getCreateSqlScript();
			is_created = true;
			return res;
		} else {
			return "";
		}
	}
	
	 

}
