package sql.sqlserver.relations;

import orm.api.relations.IRelation;
import sql.sqlserver.SqlServerException;
import sql.sqlserver.SqlTable;

public class SqlRelationManyToOne extends AbstractSqlRelation {

	
	public SqlRelationManyToOne(SqlTable table, IRelation rel) {
		super(table, rel);
	}
	
	public String getCreateSqlScript() throws SqlServerException {
		SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
		
		StringBuffer res = new StringBuffer("-- Many to One --\n");
		res.append("ALTER TABLE ")
		.append(getTable().getSqlName())
		.append(" ADD [")
		.append(getRelColumnName())
		.append("_id] bigint \nGO\n");
		
		res.append("ALTER TABLE ")
		.append(getTable().getSqlName())
		.append(" ADD CONSTRAINT FK_")
		.append(referredTable.getName())
		.append("_id FOREIGN KEY ([")
		.append(getRelColumnName())
		.append("_id]) REFERENCES  ")
		.append(referredTable.getSqlName())
		.append(" (id) ON DELETE NO ACTION ON UPDATE NO ACTION \nGO\n");
		
		return res.toString();
	}

}
