package sql.sqlserver.relations;

import orm.api.relations.IBiDirectRelation;
import orm.api.relations.IRelation;
import sql.sqlserver.ISqlBiDirectRelation;
import sql.sqlserver.SqlServerException;
import sql.sqlserver.SqlTable;

public class SqlRelationManyToOneBiDirect extends SqlRelationManyToOne implements ISqlBiDirectRelation {

	
	public SqlRelationManyToOneBiDirect(SqlTable table, IRelation rel) {
		super(table, rel);
	}
	
	public String getName() {
		return ((IBiDirectRelation)super.rel).getRelationName();
	}

	private boolean is_created = false;
	public boolean isCreated() {
		return is_created;
	}
	
	@Override
	public String getCreateSqlScript() throws SqlServerException {
		if (!is_created) {
			String res = super.getCreateSqlScript();
			is_created = true;
			return res;
		} else {
			return "";
		}
	}

}
