package sql.sqlserver.relations;

import orm.api.relations.IRelation;
import sql.sqlserver.SqlServerException;
import sql.sqlserver.SqlTable;

public class SqlRelationOneToMany extends AbstractSqlRelation {
	
	public SqlRelationOneToMany(SqlTable table, IRelation rel) {
		super(table, rel);
	}

	public String getCreateSqlScript() throws SqlServerException {
		SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
		
		StringBuffer res = new StringBuffer("-- Many to One --\n");
		res.append("ALTER TABLE ")
		.append(referredTable.getSqlName())
		.append(" ADD [")
		.append(getRelColumnName())
		.append("_id] bigint \nGO\n");
		
		res.append("ALTER TABLE ")
		.append(referredTable.getSqlName())
		.append(" ADD CONSTRAINT FK_")
		.append(table.getName())
		.append("_id FOREIGN KEY ([")
		.append(getRelColumnName())
		.append("_id]) REFERENCES  ")
		.append(table.getSqlName())
		.append(" (id) ON DELETE NO ACTION ON UPDATE NO ACTION \nGO\n");
		
		return res.toString();
	}
	
}
