package sql.sqlserver.relations;

import orm.api.relations.IRelation;
import sql.sqlserver.*;

public class SqlRelationOneToOne extends AbstractSqlRelation {

	public SqlRelationOneToOne(SqlTable table, IRelation rel) {
		super(table, rel);
	}
	
	
	public String getCreateSqlScript() throws SqlServerException {
		
		SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
			
		StringBuffer res = new StringBuffer(getCreateSqlScript_CreateNewColumnID());
		res.append("\nALTER TABLE ")
		.append(table.getSqlName())
		.append(" ADD CONSTRAINT FK_")
		.append(rel.getFieldStructure().getFieldName())
		.append("_to_")
		.append(referredTable.getName())
		.append(" FOREIGN KEY (")
		.append(rel.getFieldStructure().getFieldName())
		.append("_id")
		.append(") REFERENCES ")
		.append(referredTable.getSqlName())
		.append(" (id) ON DELETE NO ACTION ON UPDATE NO ACTION\nGO\n");
		
		return res.toString();
	
	}
	
	public String getCreateSqlScript_CreateNewColumnID() {
		StringBuffer res = new StringBuffer();
		res.append("ALTER TABLE ")
		.append(table.getSqlName())
		.append(" ADD [")
		.append(getRelColumnName())
		.append("_id")
		.append("] bigint\nGO\n");
		return res.toString();
	}
	
	
	

	
	
	
}
