package orm.api.relations;

import orm.structure.*;
import java.lang.reflect.*;

public abstract class AbstractRelation implements IRelation {
	protected Field field;
	protected RelationType relationType;
	
	protected AbstractRelation(Field f, RelationType relType) {
		field = f;
		relationType = relType;
	}
	
	public Field getField() {
		return field;
	}
	
	public abstract Class getTargetClass();
	
	public FieldStructure getFieldStructure() {
		return FieldStructure.getColumn(field);
	}
	
	public RelationType getRelationType() {
		return this.relationType;
	}
	public boolean isBiDirectional() {
		return (this instanceof IBiDirectRelation) ? true : false;
	}
}
