package orm.api.relations;

import java.lang.reflect.Field;

import orm.structure.OrmRelation;
import orm.structure.RelationType;

public class ManyToManyRelation extends AbstractRelation {
	protected Class targetClass = null;

	protected ManyToManyRelation(Field f,Class targetClass) {
		super(f, RelationType.Many_to_Many);
		this.targetClass = targetClass;
	}
	
	public Class getTargetClass(){
		return targetClass;
	}
	
	public static ManyToManyRelation getRelation(Field f) {
		OrmRelation  relation = f.getAnnotation(OrmRelation.class);
		if (!relation.isBiDirectional()) {
			return new ManyToManyRelation(f, relation.targetClass());
		} else {
			return ManyToManyBiDirectRelation.getRelation(f, relation.targetClass(), relation.biDirectionalName());
		}
	}
}
