package orm.api.relations;

import java.lang.reflect.Field;

import orm.structure.OrmRelation;
import orm.structure.RelationType;

public class ManyToOneRelation extends AbstractRelation {
	protected Class targetClass = null;

	protected ManyToOneRelation(Field f,Class targetClass) {
		super(f, RelationType.Many_to_One);
		this.targetClass = targetClass;
	}
	
	public Class getTargetClass(){
		return targetClass;
	}
	
	public static ManyToOneRelation getRelation(Field f) {
		OrmRelation  relation = f.getAnnotation(OrmRelation.class);
		if (!relation.isBiDirectional()) {
			return new ManyToOneRelation(f, relation.targetClass());
		} else {
			return ManyToOneBiDirectRelation.getRelation(f, relation.targetClass(), relation.biDirectionalName());
		}
	}
	
}