package orm.api.relations;

import java.lang.reflect.*;

import orm.structure.OrmRelation;
import orm.structure.RelationType;

public class OneToManyRelation extends AbstractRelation {
	
	protected Class targetClass = null;

	protected OneToManyRelation(Field f,Class targetClass) {
		super(f, RelationType.One_to_Many);
		this.targetClass = targetClass;
	}
	
	public static OneToManyRelation getRelation(Field f){
		OrmRelation  relation = f.getAnnotation(OrmRelation.class);
		if (!relation.isBiDirectional()) {
			return new OneToManyRelation(f, relation.targetClass());
		} else {
			return OneToManyBiDirectRelation.getRelation(f, relation.targetClass(), relation.biDirectionalName());
		}
	}
	
	public Class getTargetClass(){
		return targetClass;
	}
}
