package orm.api.relations;

import java.lang.reflect.*;

import orm.structure.OrmRelation;
import orm.structure.RelationType;

public class OneToOneRelation extends AbstractRelation {
	
	protected Class targetClass = null;
	
	protected OneToOneRelation(Field f,Class targetClass) {
		super(f, RelationType.One_to_One);
		this.targetClass = targetClass;
	}
	
	public static OneToOneRelation getRelation(Field f){
		OrmRelation  relation = f.getAnnotation(OrmRelation.class);
		if (!relation.isBiDirectional()) {
			return new OneToOneRelation(f, relation.targetClass());
		} else {
			return OneToOneBiDirectRelation.getRelation(f, relation.targetClass(), relation.biDirectionalName());
		}
	}
	
	public Class getTargetClass(){
		return targetClass;
	}
}
