package orm.structure;

import java.util.*;

/*
 * Created on Sep 5, 2006
 *
 */



public class DataStructure {
	
	protected DataStructure(Class[] classes ){
		this.classes = classes;
		classSet = new HashSet<Class>(Arrays.asList(classes));
	}
	
	protected String name=null;
	private Hashtable<Class,EntityStructure> tables = new Hashtable <Class,EntityStructure>();
	private Class[] classes = null;
	private HashSet<Class> classSet = null;
	
	/**
	 * @return Returns the name.
	 */
	
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	public synchronized void addEntityStructure(EntityStructure t) {
		tables.put(t.getEntityClass(), t);
	}
	
	public EntityStructure getEntityStructure(Class c) {
		return tables.get(c);
	}
	public EntityStructure[] getEntityStructures(){
		return tables.values().toArray(new EntityStructure[tables.size()]);
	}
	
	protected void init() {
		for(Class<?> c : classes) {
			EntityStructure t = EntityStructure.getEntityStructure(c, this);
			addEntityStructure(t);
		}
	}
	public static DataStructure getStructure(Class[] classes) {
		
		DataStructure res = new DataStructure(classes);
		
		res.init();
		res.initBaseClasses();
		return res;
	}
	
	protected void initBaseClasses() {
		for(EntityStructure t : tables.values()) {
			Class<?> baseClass = t.getEntityClass().getSuperclass();
			if (tables.containsKey(baseClass)) {
				t.setBaseEntityStructure(tables.get(baseClass));
			}
		}
	}
	
	Class[] getClasses() {
		return classes;
	}
	
	public boolean containsClass(Class c) {
		return classSet.contains(c);
	}
	
	
}
