package sql.sqlserver;

import orm.api.relations.IBiDirectRelation;
import orm.api.relations.IRelation;
import sql.sqlserver.relations.*;

public class SqlRelationFactory {
	
	public static final ISqlRelation getRelation(SqlTable t, IRelation rel) {
		
		switch(rel.getRelationType()) {
			case One_to_One:
				return (rel instanceof IBiDirectRelation) ? new SqlRelationOneToOneBiDirect(t, (IBiDirectRelation) rel) : new SqlRelationOneToOne(t,rel);
			case Many_to_Many:
				return (rel instanceof IBiDirectRelation) ? new SqlRelationManyToManyBiDirect(t, (IBiDirectRelation) rel) : new SqlRelationManyToMany(t,rel);
			case One_to_Many:
				return (rel instanceof IBiDirectRelation) ? new SqlRelationOneToManyBiDirect(t, (IBiDirectRelation) rel) : new SqlRelationOneToMany(t,rel);
			case Many_to_One:
				return (rel instanceof IBiDirectRelation) ? new SqlRelationManyToOneBiDirect(t, (IBiDirectRelation) rel) : new SqlRelationManyToOne(t,rel);
			default: return null;
		}
		
		
	}
	
}
