package sql.sqlserver.relations;

import orm.api.relations.IRelation;
import sql.sqlserver.SqlServerException;
import sql.sqlserver.SqlTable;

public class SqlRelationManyToMany extends AbstractSqlRelation {

	public SqlRelationManyToMany(SqlTable table, IRelation rel) {
		super(table, rel);
	}
	
	public String getCreateSqlScript() throws SqlServerException {
		//create link table
		SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
		StringBuffer res = new StringBuffer(createLinkedTable());
		
		return res.toString();
	}
	
	protected String linkTableName = null;
	protected String getLinkedTableName() {
		if (linkTableName == null) { 
			SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
			linkTableName = "link_" + super.getRelColumnName() + "_" + referredTable.getName();
		}
		return linkTableName;
	}
	protected String createLinkedTable() {
		SqlTable referredTable = this.getTable().getDomain().getSqlTableByClass(rel.getTargetClass());
		
		StringBuffer res =new StringBuffer();
		res.append("CREATE TABLE ")
		.append(getLinkedTableName())
		.append("\n(\nid_")
		.append(table.getName())
		.append(" bigint NOT NULL,\nid_")
		.append(referredTable.getName())
		.append(" bigint NOT NULL\n)\nGO\n")
		.append("ALTER TABLE ")
		.append(getLinkedTableName())
		.append(" ADD CONSTRAINT \n")
		.append("PK_")
		.append(getLinkedTableName())
		.append(" PRIMARY KEY CLUSTERED (id_")
		.append(table.getName())
		.append(",id_")
		.append(referredTable.getName())
		.append(") ON [PRIMARY] \nGO\n");
		//add foreign keys
		res.append("ALTER TABLE ")
		.append(getLinkedTableName())
		.append(" ADD CONSTRAINT FK_")
		.append(getLinkedTableName())
		.append("_to_")
		.append(table.getName())
		.append(" FOREIGN KEY (id_")
		.append(table.getName())
		.append(") REFERENCES ")
		.append(table.getSqlName())
		.append(" (id) ON UPDATE NO ACTION ON DELETE NO ACTION\nGO\n");
		
		res.append("ALTER TABLE ")
		.append(getLinkedTableName())
		.append(" ADD CONSTRAINT FK_")
		.append(getLinkedTableName())
		.append("_to_")
		.append(referredTable.getName())
		.append(" FOREIGN KEY (id_")
		.append(referredTable.getName())
		.append(") REFERENCES ")
		.append(referredTable.getSqlName())
		.append(" (id) ON UPDATE NO ACTION ON DELETE NO ACTION\nGO\n");
		return res.toString();
	}


	
}
